diff -ruN ../nakedmudv3.0/src/set.c src/set.c
--- ../nakedmudv3.0/src/set.c	Fri Oct  7 14:15:55 2005
+++ src/set.c	Sun Dec  4 20:03:08 2005
@@ -15,8 +15,10 @@
 
 struct set_data {
   int    num_buckets;
-  int    size;
-  LIST **buckets;
+  int           size;
+  LIST     **buckets;
+  int  (* cmp)(const void *, const void *);
+  int (* hash)(const void *);
 };
 
 struct set_iterator {
@@ -32,12 +34,22 @@
 //*****************************************************************************
 
 //
-// Find the bucket the set element belongs to
-int set_elem_bucket(void *elem, int num_buckets) {
-  // simple for now: just take the modulo
-  return ((int)elem < 0 ? -1 * (int)elem : (int)elem) % num_buckets;
-};
+// compre two elements for equality
+int gen_set_cmp(const void *key1, const void *key2) {
+  int val = (key2 - key1);
+  if(val < 0)      return -1;
+  else if(val > 0) return  1;
+  else             return  0;
+  return val;
+}
 
+//
+// hash an item
+int gen_set_hash(const void *key) {
+  int val = (int)key;
+  if(val < 0) return -val;
+  else        return  val;
+}
 
 //
 // expand a set to the new number of buckets
@@ -60,7 +72,7 @@
 
   // now, we put all of our entries back into the new buckets
   while((entry = listPop(entries)) != NULL) {
-    int bucket = set_elem_bucket(entry, set->num_buckets);
+    int bucket = set->hash(entry) % set->num_buckets;
     if(set->buckets[bucket] == NULL) set->buckets[bucket] = newList();
     listPut(set->buckets[bucket], entry);
   }
@@ -77,6 +89,8 @@
   set->buckets     = calloc(DEFAULT_SET_SIZE, sizeof(LIST *));
   set->num_buckets = DEFAULT_SET_SIZE;
   set->size        = 0;
+  set->cmp         = gen_set_cmp;
+  set->hash        = gen_set_hash;
   return set;
 }
 
@@ -105,7 +119,7 @@
     setExpand(set, (set->num_buckets * 150)/100);
 
   // find out what bucket we belong to
-  int hash_bucket = set_elem_bucket(elem, set->num_buckets);
+  int hash_bucket = set->hash(elem) % set->num_buckets;
 
   // add us to the bucket
   if(set->buckets[hash_bucket] == NULL)
@@ -117,20 +131,20 @@
 
 void setRemove(SET *set, void *elem) {
   // find out what bucket we belong to
-  int hash_bucket = set_elem_bucket(elem, set->num_buckets);
+  int hash_bucket = set->hash(elem) % set->num_buckets;
 
   // see if the bucket exists
   if(set->buckets[hash_bucket] != NULL)
-    if(listRemove(set->buckets[hash_bucket], elem))
+    if(listRemoveWith(set->buckets[hash_bucket], elem, set->cmp))
       set->size--;
 }
 
-int setIn(SET *set, void *elem) {
+int setIn(SET *set, const void *elem) {
   // find out what bucket we belong to
-  int hash_bucket = set_elem_bucket(elem, set->num_buckets);
+  int hash_bucket = set->hash(elem) % set->num_buckets;
 
   if(set->buckets[hash_bucket] != NULL)
-    return listIn(set->buckets[hash_bucket], elem);
+    return (listGetWith(set->buckets[hash_bucket], elem, set->cmp) != NULL);
   else
     return 0;
 }
@@ -143,15 +157,16 @@
     if(set->buckets[i] == NULL) continue;
     LIST_ITERATOR *list_i = newListIterator(set->buckets[i]);
     void            *elem = NULL;
-    for(;(elem=listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i))
+    ITERATE_LIST(elem, list_i) {
       listPut(list, elem);
-    deleteListIterator(list_i);
+    } deleteListIterator(list_i);
   }
   return list;
 }
 
 SET  *setCopy(SET *set) {
   SET *newset = newSet();
+  setChangeHashing(newset, set->cmp, set->hash);
   setExpand(newset, set->num_buckets);
   SET_ITERATOR *set_i = newSetIterator(set);
   void          *elem = NULL;
@@ -203,6 +218,11 @@
       setRemove(intersection, elem);
   } deleteSetIterator(set_i);
   return intersection;
+}
+
+void setChangeHashing(SET *set, void *cmp_func, void *hash_func) {
+  set->cmp  = cmp_func;
+  set->hash = hash_func;
 }
 
 
diff -ruN ../nakedmudv3.0/src/set.h src/set.h
--- ../nakedmudv3.0/src/set.h	Fri Oct  7 14:15:55 2005
+++ src/set.h	Sun Dec  4 20:03:08 2005
@@ -15,12 +15,13 @@
 void  deleteSet      (SET *set);
 void  setPut         (SET *set, void *elem);
 void  setRemove      (SET *set, void *elem);
-int   setIn          (SET *set, void *elem);
+int   setIn          (SET *set, const void *elem);
 int   setSize        (SET *set);
 LIST *setCollect     (SET *set);
 SET  *setCopy        (SET *set);
 SET  *setUnion       (SET *set1, SET *set2);
 SET  *setIntersection(SET *set1, SET *set2);
+void setChangeHashing(SET *set, void *cmp_func, void *hash_func);
 
 
 
diff -ruN ../nakedmudv3.0/src/socials/socials.c src/socials/socials.c
--- ../nakedmudv3.0/src/socials/socials.c	Fri Oct  7 14:15:55 2005
+++ src/socials/socials.c	Sun Dec  4 20:03:07 2005
@@ -478,18 +478,20 @@
 void add_social(SOCIAL_DATA *social) {
   // for each of our keywords, go through and 
   // unlink all of the current socials and link the new one
-  int i, num_cmds = 0;
-  char **cmd_list = parse_keywords(social->cmds, &num_cmds);
+  LIST       *cmd_list = parse_keywords(social->cmds);
+  LIST_ITERATOR *cmd_i = newListIterator(cmd_list);
+  char            *cmd = NULL;
 
-  for(i = 0; i < num_cmds; i++) {
-    unlink_social(cmd_list[i]);
-    hashPut(social_table, cmd_list[i], social);
+  ITERATE_LIST(cmd, cmd_i) {
+    unlink_social(cmd);
+    hashPut(social_table, cmd, social);
     // add the new command to the game
-    add_cmd(cmd_list[i], NULL, cmd_social, social->min_pos, social->max_pos,
+    add_cmd(cmd, NULL, cmd_social, social->min_pos, social->max_pos,
 	    "player", TRUE, FALSE);
-    free(cmd_list[i]);
-  }
-  free(cmd_list);
+  } deleteListIterator(cmd_i);
+
+  // garbage collection
+  deleteListWith(cmd_list, free);
 
   // save changes
   if(!in_social_init)
diff -ruN ../nakedmudv3.0/src/socket.c src/socket.c
--- ../nakedmudv3.0/src/socket.c	Fri Oct  7 14:15:55 2005
+++ src/socket.c	Sun Dec  4 20:03:08 2005
@@ -57,6 +57,7 @@
 
   LIST          * input_handlers;// a stack of our input handlers and prompts
   LIST          * input;         // lines of input we have received
+  LIST          * command_hist;  // the commands we've executed in the past
 
   unsigned char   compressing;                 /* MCCP support */
   z_stream      * out_compress;                /* MCCP support */
@@ -755,12 +756,13 @@
 //
 //*****************************************************************************
 void deleteSocket(SOCKET_DATA *sock) {
-  if(sock->hostname)       free(sock->hostname);
-  if(sock->page_string)    free(sock->page_string);
-  if(sock->text_editor)    deleteBuffer(sock->text_editor);
-  if(sock->input_handlers) deleteListWith(sock->input_handlers, free);
-  if(sock->input)          deleteListWith(sock->input, free);
-  if(sock->auxiliary)      deleteAuxiliaryData(sock->auxiliary);
+  if(sock->hostname)         free(sock->hostname);
+  if(sock->page_string)      free(sock->page_string);
+  if(sock->text_editor)      deleteBuffer(sock->text_editor);
+  if(sock->input_handlers)   deleteListWith(sock->input_handlers, free);
+  if(sock->input)            deleteListWith(sock->input, free);
+  if(sock->command_hist)     deleteListWith(sock->command_hist, free);
+  if(sock->auxiliary)        deleteAuxiliaryData(sock->auxiliary);
   free(sock);
 }
 
@@ -771,11 +773,13 @@
   if(sock_new->input_handlers) deleteListWith(sock_new->input_handlers, free);
   if(sock_new->auxiliary)      deleteAuxiliaryData(sock_new->auxiliary);
   if(sock_new->input)          deleteListWith(sock_new->input, free);
+  if(sock_new->command_hist)   deleteListWith(sock_new->command_hist, free);
 
   bzero(sock_new, sizeof(*sock_new));
   sock_new->auxiliary = newAuxiliaryData(AUXILIARY_TYPE_SOCKET);
   sock_new->input_handlers = newList();
   sock_new->input          = newList();
+  sock_new->command_hist   = newList();
   socketPushInputHandler(sock_new, handle_new_connections, NULL);
   sock_new->control        = sock;
   sock_new->lookup_status  = TSTATE_LOOKUP;
@@ -964,6 +968,9 @@
     /* Is there a new command pending ? */
     if (sock->cmd_read) {
       socketGetInputHandler(sock)(sock, sock->next_command);
+      listPut(sock->command_hist, strdup(sock->next_command));
+      if(listSize(sock->command_hist) > 100)
+	free(listRemoveNum(sock->command_hist, 100));
       sock->next_command[0] = '\0';
       sock->cmd_read = FALSE;
     }
@@ -1123,7 +1130,7 @@
   sprintf(buf, "\n\r <*>            The world starts spinning             <*>\n\r");
 
   // execute our shutdown hooks
-  hookRun("shutdown", NULL, NULL, NULL);
+  hookRun("shutdown");
 
   // For each playing descriptor, save its character and account
   ITERATE_LIST(sock, sock_i) {
@@ -1192,6 +1199,13 @@
   pair->handler = handler;
   pair->prompt  = prompt;
   listPush(socket->input_handlers, pair);
+}
+
+const char *socketGetLastCmd(SOCKET_DATA *sock) {
+  if(listSize(sock->command_hist) == 0)
+    return "";
+  else
+    return listHead(sock->command_hist);
 }
 
 void socketPopInputHandler   ( SOCKET_DATA *socket) {
diff -ruN ../nakedmudv3.0/src/socket.h src/socket.h
--- ../nakedmudv3.0/src/socket.h	Fri Oct  7 14:15:55 2005
+++ src/socket.h	Sun Dec  4 20:03:08 2005
@@ -55,5 +55,6 @@
 void socketQueueCommand       ( SOCKET_DATA *sock, const char *cmd);
 
 void socketBustPrompt         ( SOCKET_DATA *sock);
+const char *socketGetLastCmd  ( SOCKET_DATA *sock);
 
 #endif // SOCKET_H
diff -ruN ../nakedmudv3.0/src/time/time.c src/time/time.c
--- ../nakedmudv3.0/src/time/time.c	Fri Oct  7 14:15:55 2005
+++ src/time/time.c	Sun Dec  4 20:03:07 2005
@@ -26,7 +26,9 @@
 //*****************************************************************************
 // mandatory modules
 //*****************************************************************************
+#include "../scripts/scripts.h"
 #include "../scripts/pyroom.h"
+#include "../scripts/pymud.h"
 
 
 
@@ -190,12 +192,37 @@
 
 
 //*****************************************************************************
+// Python methods
+//*****************************************************************************
+PyObject *PyMud_GetHour(PyObject *self) {
+  return Py_BuildValue("i", get_hour());
+}
+
+PyObject *PyMud_IsMorning(PyObject *self) {
+  return Py_BuildValue("i", is_morning());
+}
+
+PyObject *PyMud_IsAfternoon(PyObject *self) {
+  return Py_BuildValue("i", is_afternoon());
+}
+
+PyObject *PyMud_IsEvening(PyObject *self) {
+  return Py_BuildValue("i", is_evening());
+}
+
+PyObject *PyMud_IsNight(PyObject *self) {
+  return Py_BuildValue("i", is_night());
+}
+
+
+
+//*****************************************************************************
 // time handling functions
 //*****************************************************************************
 
 //
 // If it's in the night, swap out our desc for the room's night desc
-void room_nightdesc_hook(BUFFER *desc, ROOM_DATA *room, void *none) {
+void room_nightdesc_hook(BUFFER *desc, ROOM_DATA *room, CHAR_DATA *looker) {
   if((is_evening() || is_night()) && *roomGetNightDesc(room)) {
     // if it's the room desc and not an edesc, cat the night desc...
     if(!strcasecmp(bufferString(desc), roomGetDesc(room))) {
@@ -269,10 +296,20 @@
   // add a nightdesc get-setter to rooms
   PyRoom_addGetSetter("ndesc", PyRoom_getndesc, PyRoom_setndesc,
 		      "the room's night desc");
+  PyRoom_addGetSetter("night_desc", PyRoom_getndesc, PyRoom_setndesc,
+		      "the room's night desc");
+
+  // add our mud methods
+  PyMud_addMethod("get_hour",     PyMud_GetHour,     METH_NOARGS, NULL);
+  PyMud_addMethod("is_morning",   PyMud_IsMorning,   METH_NOARGS, NULL);
+  PyMud_addMethod("is_afternoon", PyMud_IsAfternoon, METH_NOARGS, NULL);
+  PyMud_addMethod("is_evening",   PyMud_IsEvening,   METH_NOARGS, NULL);
+  PyMud_addMethod("is_night",     PyMud_IsNight,     METH_NOARGS, NULL);
   
   // add our set fields
 #ifdef MODULE_SET_VAL
-  add_set("ndesc", SET_ROOM, SET_TYPE_STRING, roomSetNightDesc, NULL);
+  add_set("ndesc",      SET_ROOM, SET_TYPE_STRING, roomSetNightDesc, NULL);
+  add_set("night_desc", SET_ROOM, SET_TYPE_STRING, roomSetNightDesc, NULL);
 #endif
 
   // add the time command
diff -ruN ../nakedmudv3.0/src/utils.c src/utils.c
--- ../nakedmudv3.0/src/utils.c	Fri Oct  7 14:15:55 2005
+++ src/utils.c	Sun Dec  4 20:03:08 2005
@@ -251,9 +251,7 @@
       }
       break;
     }
-  }
-
-  deleteListIterator(mob_i);
+  } deleteListIterator(mob_i);
   return dMob;
 }
 
@@ -524,10 +522,14 @@
 
 
 //
-// Calculates how many characters until we hit the next space
-//
+// Calculates how many characters until we hit the next whitespace. Newlines,
+// tabs, and spaces are treated as whitespace.
 int next_space_in(const char *string) {
-  return next_letter_in(string, ' ');
+  int i = 0;
+  for(i = 0; string[i] != '\0'; i++)
+    if(isspace(string[i]))
+      return i;
+  return -1; // none found
 }
 
 
@@ -681,30 +683,45 @@
 //
 // Return 0 if the head of the string does not match any of our
 // keywords. Returns the length of the keyword if it does match
-//
 int find_keyword(const char *keywords, const char *string) {
-  int i, len = 0, num_keywords = 0;
-  char **words = parse_keywords(keywords, &num_keywords);
+  LIST           *words = parse_keywords(keywords);
+  LIST_ITERATOR *word_i = newListIterator(words);
+  char            *word = NULL;
+  int               len = 0;
 
   // try to find the longest keyword
-  for(i = 0; i < num_keywords; i++) {
-    int word_len = strlen(words[i]);
-    if(!strncasecmp(words[i], string, word_len) && word_len > len)
+  ITERATE_LIST(word, word_i) {
+    int word_len = strlen(word);
+    if(!strncasecmp(word, string, word_len) && word_len > len)
       len = word_len;
-    free(words[i]);
-  }
-  if(words) free(words);
+  } deleteListIterator(word_i);
+  deleteListWith(words, free);
 
   return len;
 }
 
+//
+// returns whether or not a keyword exists twice in the list
+bool dup_keywords_exist(const char *keywords) {
+  LIST           *keys = parse_keywords(keywords);
+  char            *key = NULL;
+  bool       dup_found = FALSE;
+
+  while( !dup_found && (key = listPop(keys)) != NULL) {
+    if(listGetWith(keys, key, strcasecmp) != NULL)
+      dup_found = TRUE;
+    free(key);
+  } deleteListWith(keys, free);
+
+  return dup_found;
+}
 
 //
 // Return a list of all the strings in this list. String are separated by the
-// delimeter.
-char **parse_strings(const char *string, char delimeter, int *num_strings) {
-  // we assume none to start off with
-  *num_strings = 0;
+// delimeter. The list and contents must be deleted after use.
+LIST *parse_strings(const char *string, char delimeter) {
+  // make our list that we will be returning
+  LIST *list = newList();
 
   // first, we check if the string have any non-spaces
   int i;
@@ -718,34 +735,29 @@
 
   // we didn't find any non-spaces. Return NULL
   if(!nonspace_found)
-    return NULL;
+    return list;
 
-  *num_strings = count_letters(string, delimeter, strlen(string)) + 1;
-  if(*num_strings == 0)
-    return NULL;
-
-  char **string_names = malloc(sizeof(char *) * *num_strings);
-
-  int string_count = 0;
-  while(string_count < *num_strings - 1) {
+  // find all of our keywords
+  while(*string != '\0') {
     i = 0;
     // find the endpoint
-    while(string[i] != delimeter)
+    while(string[i] != delimeter && string[i] != '\0')
       i++;
 
     char buf[i+1];
     strncpy(buf, string, i); buf[i] = '\0';
     trim(buf); // skip all whitespaces
-    string_names[string_count] = strdup(buf);
-    // skip everything we just copied
-    string = &string[i+1];
-    string_count++;
-  }
-  // get the last one, and trim it
-  string_names[*num_strings - 1] = strdup(string);
-  trim(string_names[*num_strings - 1]);
 
-  return string_names;
+    // make sure something still exists. If it does, queue it
+    if(*buf != '\0')
+      listQueue(list, strdup(buf));
+
+    // skip everything we just copied, plus our delimeter
+    string = &string[i+(string[i] != '\0' ? 1 : 0)];
+  }
+
+  // return whatever we found
+  return list;
 }
 
 
@@ -753,54 +765,61 @@
 // return a list of all the unique keywords found in the keywords string
 // keywords can be more than one word long (e.g. blue flame) and each
 // keyword must be separated by a comma
-//
-char **parse_keywords(const char *keywords, int *num_keywords) {
-  return parse_strings(keywords, ',', num_keywords);
+LIST *parse_keywords(const char *keywords) {
+  return parse_strings(keywords, ',');
 }
 
 
 //
 // If the keyword does not already exist, add it to the keyword list
 // keywords may be freed and re-built in the process, to make room
-//
 void add_keyword(char **keywords_ptr, const char *word) {
   // if it's already a keyword, do nothing
   if(!is_keyword(*keywords_ptr, word, FALSE)) {
-    char buf[MAX_BUFFER];
-    // copy everything over
-    strcpy(buf, *keywords_ptr);
-    // print the new word
-    strcat(buf, ", ");
-    strcat(buf, word);
-    // free the old string
+    BUFFER *buf = newBuffer(MAX_BUFFER);
+    // make our new keyword list
+    bprintf(buf, "%s%s%s", *keywords_ptr, (**keywords_ptr ? ", " : ""), word);
+    // free the old string, copy the new one
     free(*keywords_ptr);
-    // copy the new one
-    *keywords_ptr = strdup(buf);
+    *keywords_ptr = strdup(bufferString(buf));
+    // clean up our garbage
+    deleteBuffer(buf);
   }
 }
 
 
 //
-// go through the keywords and if word is found, remove it
-//
+// go through the keywords and if the word is found, remove it
 void remove_keyword(char *keywords, const char *word) {
-  int i, key_i = 0, num_keywords = 0;
-  char **words = parse_keywords(keywords, &num_keywords);
+  LIST *words = parse_keywords(keywords);
+  char  *copy = NULL;
+  int   count = 0;
+
+  // remove all copies of it
+  while( (copy = listRemoveWith(words, word, strcasecmp)) != NULL) {
+    free(copy);
+    count++;
+  }
+
+  // did we find a copy of the bad keyword?
+  if(count > 0) {
+    LIST_ITERATOR *word_i = newListIterator(words);
+    int             key_i = 0;
+    count = 0;
 
-  // clear the current list... we will rebuild it
-  *keywords = '\0';
+    // clear the current keywords... we'll rebuild them
+    *keywords = '\0';
 
-  // go through and add them all back into keywords. If we
-  // ever encounter word, then leave it out
-  for(i = 0; i < num_keywords; i++) {
-    if(strcasecmp(words[i], word) != 0) {
-      key_i += sprintf(keywords+key_i, "%s", words[i]);
-      if(i < num_keywords-1 && strcasecmp(words[i+1], word) != 0)
+    ITERATE_LIST(copy, word_i) {
+      count++;
+      key_i += sprintf(keywords+key_i, "%s", copy);
+      if(count < listSize(words) - 1)
 	key_i += sprintf(keywords+key_i, ", ");
-    }
-    free(words[i]);
+    } deleteListIterator(word_i);
   }
-  free(words);
+
+  // clean up our garbage
+  deleteListWith(words, free);
 }
 
 
diff -ruN ../nakedmudv3.0/src/utils.h src/utils.h
--- ../nakedmudv3.0/src/utils.h	Fri Oct  7 14:15:55 2005
+++ src/utils.h	Sun Dec  4 20:03:08 2005
@@ -103,8 +103,9 @@
 #define AN(string)         (strchr("AEIOU", toupper(*string)) ? "an" : "a")
 #define strdupsafe(string) strdup(string ? string : "")
 
-char **parse_strings      (const char *string, char delimeter,int *num_strings);
-char **parse_keywords     (const char *keywords, int *num_keywords);
+LIST *parse_strings       (const char *string, char delimeter);
+LIST *parse_keywords      (const char *keywords);
+bool dup_keywords_exist   (const char *keywords);
 bool is_keyword           (const char *keywords, const char *word, 
 			   bool abbrev_ok);
 int  find_keyword         (const char *keywords, const char *string);
diff -ruN ../nakedmudv3.0/src/zone.c src/zone.c
--- ../nakedmudv3.0/src/zone.c	Fri Oct  7 14:15:55 2005
+++ src/zone.c	Sun Dec  4 20:03:08 2005
@@ -124,7 +124,7 @@
   zone->pulse--;
   if(zone->pulse == 0) {
     zone->pulse = zone->pulse_timer;
-    hookRun("reset", zone, NULL, NULL);
+    hookRun("reset", zone);
   }
 }
 
